﻿using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _145864
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraCalendarInfo1.DaysOfWeek[DayOfWeekEnum.Monday].WorkDayStartTime = DateTime.Now.Date.AddHours(5);
            this.ultraCalendarInfo1.DaysOfWeek[DayOfWeekEnum.Monday].WorkDayEndTime = DateTime.Now.Date.AddHours(17);

            this.ultraCalendarInfo1.DaysOfWeek[DayOfWeekEnum.Friday].WorkDayStartTime = DateTime.Now.Date.AddHours(5);
            this.ultraCalendarInfo1.DaysOfWeek[DayOfWeekEnum.Friday].WorkDayEndTime = DateTime.Now.Date.AddHours(17);

            //this.ultraCalendarInfo1.LogicalDayDuration = new TimeSpan(12, 0, 0);
            //this.ultraCalendarInfo1.LogicalDayOffset = new TimeSpan(5, 0, 0);
            this.ultraCalendarInfo1.TaskWorkingHourMode = TaskWorkingHourMode.AutoAdjust;

            Infragistics.Win.UltraWinSchedule.Owner owner =
                ultraCalendarInfo1.Owners.Add("owner1");

            owner.DayOfWeekSettings[DayOfWeekEnum.Monday].WorkDayStartTime = DateTime.Today.Date.AddHours(4);
            owner.DayOfWeekSettings[DayOfWeekEnum.Monday].WorkDayEndTime = DateTime.Today.Date.AddHours(16);

            owner.DayOfWeekSettings[DayOfWeekEnum.Thursday].WorkDayStartTime = DateTime.Today.Date.AddHours(4);
            owner.DayOfWeekSettings[DayOfWeekEnum.Thursday].WorkDayEndTime = DateTime.Today.Date.AddHours(16);
           
            owner.RecurringDateSettings.Add(schedule980_OnFridays(11, 23));
            owner.RecurringDateSettings.Add(schedule980_OffFridays());


            owner =
                ultraCalendarInfo1.Owners.Add("owner2");
            owner.DayOfWeekSettings[System.DayOfWeek.Monday].WorkDayStartTime = DateTime.Today.Date.AddHours(5);
            owner.DayOfWeekSettings[System.DayOfWeek.Monday].WorkDayEndTime = DateTime.Today.Date.AddHours(13);

            owner.DayOfWeekSettings[System.DayOfWeek.Tuesday].WorkDayStartTime = DateTime.Today.Date.AddHours(7);
            owner.DayOfWeekSettings[System.DayOfWeek.Tuesday].WorkDayEndTime = DateTime.Today.Date.AddHours(17);

            ultraCalendarInfo1.Owners.UnassignedOwner.Visible = false;
            

        }

        OwnerRecurringDateSettings schedule980_OnFridays(double start, double end)
        {
            DateRecurrence onFriday = new DateRecurrence(start980OnFridayScheduleA()); // first 9/80A friday ON
            onFriday.RangeEndDate = end980OnFridayScheduleA(); // last 9/80A friday ON
            onFriday.PatternFrequency = RecurrencePatternFrequency.Weekly;
            onFriday.PatternInterval = 2; // every 2 weeks
            onFriday.PatternDaysOfWeek = RecurrencePatternDaysOfWeek.Friday;  // every other friday ON
            OwnerRecurringDateSettings onFridaysSettings = new OwnerRecurringDateSettings(onFriday);
            onFridaysSettings.WorkingHours.Add(new TimeRange(TimeSpan.FromHours(start), TimeSpan.FromHours(end))); // ON fridays
            return onFridaysSettings;
        }

        private DateTime end980OnFridayScheduleA()
        {
            return DateTime.Now.Date.AddMonths(6);
        }

        private DateTime start980OnFridayScheduleA()
        {
            return DateTime.Now.Date;
        }

        OwnerRecurringDateSettings schedule980_OffFridays()
        {
            DateRecurrence offFriday = new DateRecurrence(start980OffFridayScheduleA()); // first 9/80A friday OFF
            offFriday.RangeEndDate = end980OffFridayScheduleA(); // last 9/80A friday OFF
            offFriday.PatternFrequency = RecurrencePatternFrequency.Weekly;
            offFriday.PatternInterval = 2; // every 2 weeks
            offFriday.PatternDaysOfWeek = RecurrencePatternDaysOfWeek.Friday; // every other friday OFF
            OwnerRecurringDateSettings offFridaysSettings = new OwnerRecurringDateSettings(offFriday);
            //offFridaysSettings.WorkingHours.Add(new TimeRange(TimeSpan.FromHours(0.0), TimeSpan.FromHours(0.0))); // OFF fridays
            //offFridaysSettings.WorkingHours.Remove( new TimeRange( TimeSpan.FromHours(0.0), TimeSpan.FromHours(24.0) )); // all day is off
            //offFridaysSettings.WorkingHours.Remove(new TimeRange(TimeSpan.FromHours(6.0), TimeSpan.FromHours(20.0))); // all day is off
            //offFridaysSettings.WorkingHours.Add(new TimeRange(TimeSpan.FromHours(5.1), TimeSpan.FromHours(5.2))); // OFF fridays
            //offFridaysSettings.WorkingHours.Add(new TimeRange(TimeSpan.FromHours(5.1), TimeSpan.FromHours(6.2))); // OFF fridays
            offFridaysSettings.IsWorkDay = DefaultableBoolean.False;
            return offFridaysSettings;
        }

        private DateTime end980OffFridayScheduleA()
        {
            return DateTime.Now.Date.AddDays(7).AddMonths(6);
        }

        private DateTime start980OffFridayScheduleA()
        {
            return DateTime.Now.Date.AddDays(7);
        }

    }
}
